Index: trunk/SophyaPI/PIext/Makefile
===================================================================
--- trunk/SophyaPI/PIext/Makefile	(revision 1373)
+++ trunk/SophyaPI/PIext/Makefile	(revision 1374)
@@ -301,4 +301,26 @@
  $(INC)piperiodx.h \
  $(INC)periodic.h \
+ $(INC)fitsautoreader.h \
+ $(INC)fitsfile.h \
+ $(EXTINCPATH)FitsIO/fitsio.h \
+ $(EXTINCPATH)FitsIO/longnam.h \
+ $(INC)fitstarray.h \
+ $(INC)fitsspherehealpix.h \
+ $(INC)spherehealpix.h \
+ $(INC)sphericalmap.h \
+ $(INC)smathconst.h \
+ $(INC)pixelmap.h \
+ $(INC)spherepos.h \
+ $(INC)unitvector.h \
+ $(INC)vector3d.h \
+ $(INC)longlat.h \
+ $(INC)utilgeom.h \
+ $(INC)HEALPixUtils.h \
+ $(INC)fitsntuple.h \
+ $(INC)ntuple.h \
+ $(INC)fitsxntuple.h \
+ $(INC)xntuple.h \
+ $(INC)fitslocalmap.h \
+ $(INC)localmap.h \
  $(INC)pisurfdr.h pipodrw.h \
  $(INC)histos2.h \
@@ -460,5 +482,10 @@
  $(INC)objfitter.h \
  $(INC)cimage.h \
- $(INC)fioarr.h
+ $(INC)fioarr.h \
+ $(INC)fitsntuple.h \
+ $(INC)fitsfile.h \
+ $(EXTINCPATH)FitsIO/fitsio.h \
+ $(EXTINCPATH)FitsIO/longnam.h \
+ $(INC)fitsxntuple.h
 $(OBJ)nomimagadapter.o: nomimagadapter.cc \
  $(INC)machdefs.h \
@@ -509,5 +536,9 @@
  $(INC)histos.h \
  $(INC)histos2.h \
- $(INC)hisprof.h
+ $(INC)hisprof.h \
+ $(INC)fitstarray.h \
+ $(INC)fitsfile.h \
+ $(EXTINCPATH)FitsIO/fitsio.h \
+ $(EXTINCPATH)FitsIO/longnam.h
 $(OBJ)nomskymapadapter.o: nomskymapadapter.cc \
  $(INC)machdefs.h \
@@ -569,5 +600,10 @@
  $(INC)fiospherehealpix.h \
  $(INC)fiolocalmap.h pitvmaad.h \
- $(INC)complexios.h
+ $(INC)complexios.h \
+ $(INC)fitsspherehealpix.h \
+ $(INC)fitsfile.h \
+ $(EXTINCPATH)FitsIO/fitsio.h \
+ $(EXTINCPATH)FitsIO/longnam.h \
+ $(INC)fitslocalmap.h
 $(OBJ)nomspecrespadapter.o: nomspecrespadapter.cc \
  $(INC)machdefs.h nomspecrespadapter.h \
@@ -657,55 +693,5 @@
  $(INC)utils.h \
  $(INC)perrors.h \
- $(INC)fmath.h \
- $(INC)fioarr.h
-$(OBJ)nomtmatvecadapter.o: nomtmatvecadapter.cc \
- $(INC)machdefs.h \
- $(INC)datatype.h \
- $(INC)tvector.h \
- $(INC)tmatrix.h \
- $(INC)tarray.h \
- $(INC)basarr.h \
- $(INC)anydataobj.h \
- $(INC)mutyv.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)ppersist.h \
- $(INC)pexceptions.h \
- $(INC)gnumd5.h \
- $(INC)ndatablock.h \
- $(INC)utilarr.h \
- $(INC)objfitter.h \
- $(INC)cimage.h \
- $(INC)fioarr.h \
- $(INC)histos.h \
- $(INC)peida.h \
- $(INC)utils.h \
- $(INC)perrors.h \
- $(INC)fmath.h \
- $(INC)histos2.h \
- $(INC)hisprof.h \
- $(INC)generalfit.h \
- $(INC)generaldata.h \
- $(INC)ntupintf.h \
- $(INC)poly.h nomtmatvecadapter.h \
- nomgadapter.h $(INC)pidrawer.h \
- $(INC)pibwdggen.h \
- $(INC)pisysdep.h \
- $(INC)piwdgx.h \
- $(INC)piwdggen.h \
- $(INC)pimsghandler.h \
- $(INC)picolist.h \
- $(INC)picmap.h \
- $(INC)picmapx.h \
- $(INC)picmapgen.h \
- $(INC)pigraphx.h \
- $(INC)pigraphgen.h \
- $(INC)pifontx.h \
- $(INC)pifontgen.h \
- $(INC)pigraphuc.h \
- $(INC)pievthandler.h \
- $(INC)psfile.h \
- $(INC)parradapter.h \
- $(INC)lut.h \
+ $(INC)fmath.h pitvmaad.h \
  $(INC)piscdrawwdg.h \
  $(INC)pibwdgx.h \
@@ -716,5 +702,72 @@
  $(INC)piwindowgen.h \
  $(INC)picontainerx.h \
- $(INC)picontainergen.h pitvmaad.h
+ $(INC)picontainergen.h \
+ $(INC)fioarr.h \
+ $(INC)fitstarray.h \
+ $(INC)fitsfile.h \
+ $(EXTINCPATH)FitsIO/fitsio.h \
+ $(EXTINCPATH)FitsIO/longnam.h
+$(OBJ)nomtmatvecadapter.o: nomtmatvecadapter.cc \
+ $(INC)machdefs.h \
+ $(INC)datatype.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)mutyv.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)pexceptions.h \
+ $(INC)gnumd5.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h \
+ $(INC)objfitter.h \
+ $(INC)cimage.h \
+ $(INC)fioarr.h \
+ $(INC)histos.h \
+ $(INC)peida.h \
+ $(INC)utils.h \
+ $(INC)perrors.h \
+ $(INC)fmath.h \
+ $(INC)histos2.h \
+ $(INC)hisprof.h \
+ $(INC)generalfit.h \
+ $(INC)generaldata.h \
+ $(INC)ntupintf.h \
+ $(INC)poly.h nomtmatvecadapter.h \
+ nomgadapter.h $(INC)pidrawer.h \
+ $(INC)pibwdggen.h \
+ $(INC)pisysdep.h \
+ $(INC)piwdgx.h \
+ $(INC)piwdggen.h \
+ $(INC)pimsghandler.h \
+ $(INC)picolist.h \
+ $(INC)picmap.h \
+ $(INC)picmapx.h \
+ $(INC)picmapgen.h \
+ $(INC)pigraphx.h \
+ $(INC)pigraphgen.h \
+ $(INC)pifontx.h \
+ $(INC)pifontgen.h \
+ $(INC)pigraphuc.h \
+ $(INC)pievthandler.h \
+ $(INC)psfile.h \
+ $(INC)parradapter.h \
+ $(INC)lut.h \
+ $(INC)piscdrawwdg.h \
+ $(INC)pibwdgx.h \
+ $(INC)pigraphps.h \
+ $(INC)pistdwdgx.h \
+ $(INC)pistdwdggen.h \
+ $(INC)piwindowx.h \
+ $(INC)piwindowgen.h \
+ $(INC)picontainerx.h \
+ $(INC)picontainergen.h pitvmaad.h \
+ $(INC)fitstarray.h \
+ $(INC)fitsfile.h \
+ $(EXTINCPATH)FitsIO/fitsio.h \
+ $(EXTINCPATH)FitsIO/longnam.h
 $(OBJ)pawexecut.o: pawexecut.cc $(INC)strutil.h \
  $(INC)histos.h \
Index: trunk/SophyaPI/ProgPI/Makefile
===================================================================
--- trunk/SophyaPI/ProgPI/Makefile	(revision 1373)
+++ trunk/SophyaPI/ProgPI/Makefile	(revision 1374)
@@ -32,4 +32,63 @@
 	$(LINK.cc) $^ $(LOADLIBES) $(LDLIBS) -o $@ 
   
+$(OBJ)cxx_spiapp.o: cxx_spiapp.cc $(INC)machdefs.h \
+ $(INC)systools.h \
+ $(INC)sophyainit.h \
+ $(INC)ppersist.h \
+ $(INC)pexceptions.h \
+ $(INC)gnumd5.h \
+ $(INC)ndatablock.h \
+ $(INC)anydataobj.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)mutyv.h \
+ $(INC)pdlmgr.h \
+ $(INC)perrors.h \
+ $(INC)srandgen.h \
+ $(INC)strutil.h \
+ $(INC)ctimer.h \
+ $(INC)timing.h \
+ $(INC)ntools.h \
+ $(INC)ntoolsinit.h \
+ $(INC)tarrinit.h \
+ $(INC)nbconst.h \
+ $(INC)fmath.h \
+ $(INC)nbrandom.h \
+ $(INC)perandom.h \
+ $(INC)histos.h \
+ $(INC)peida.h \
+ $(INC)utils.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)utilarr.h \
+ $(INC)nbtri.h \
+ $(INC)linfit.h \
+ $(INC)sopemtx.h \
+ $(INC)poly.h \
+ $(INC)datatypes.h \
+ $(INC)cimage.h \
+ $(INC)fioarr.h \
+ $(INC)dynccd.h \
+ $(INC)generaldata.h \
+ $(INC)ntupintf.h \
+ $(INC)generalfit.h \
+ $(INC)fct1dfit.h \
+ $(INC)fct2dfit.h \
+ $(INC)objfitter.h \
+ $(INC)histos2.h \
+ $(INC)hisprof.h \
+ $(INC)fftpserver.h \
+ $(INC)fftservintf.h \
+ $(INC)array.h \
+ $(INC)matharr.h \
+ $(INC)histats.h \
+ $(INC)histinit.h \
+ $(INC)ntuple.h \
+ $(INC)xntuple.h \
+ $(INC)nobjmgr.h \
+ $(INC)dlftypes.h \
+ $(INC)servnobjm.h cxx_spiapp.h
 $(OBJ)piapp.o: piapp.cc $(INC)pistdimgapp.h \
  $(INC)pisysdep.h \
@@ -42,4 +101,5 @@
  $(INC)piwdgx.h \
  $(INC)piwdggen.h \
+ $(INC)picolist.h \
  $(INC)pimenubarx.h \
  $(INC)pimenubargen.h \
@@ -82,4 +142,7 @@
  $(INC)pexceptions.h \
  $(INC)gnumd5.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)mutyv.h \
  $(INC)dlftypes.h \
  $(INC)piacmd.h \
@@ -98,5 +161,5 @@
  $(INC)tarrinit.h \
  $(INC)sophyainit.h
-$(OBJ)sopiamodule.o: sopiamodule.cc \
+$(OBJ)rznoisemodule.o: rznoisemodule.cc \
  $(INC)machdefs.h \
  $(INC)piacmd.h \
@@ -108,4 +171,7 @@
  $(INC)pexceptions.h \
  $(INC)gnumd5.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)mutyv.h \
  $(INC)pistdimgapp.h \
  $(INC)pisysdep.h \
@@ -117,4 +183,5 @@
  $(INC)piwdgx.h \
  $(INC)piwdggen.h \
+ $(INC)picolist.h \
  $(INC)pimenubarx.h \
  $(INC)pimenubargen.h \
@@ -163,6 +230,4 @@
  $(INC)tarray.h \
  $(INC)basarr.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
  $(INC)ndatablock.h \
  $(INC)utilarr.h \
@@ -173,2 +238,79 @@
  $(INC)piscdrawwdg.h \
  $(INC)ctimer.h
+$(OBJ)sopiamodule.o: sopiamodule.cc \
+ $(INC)machdefs.h \
+ $(INC)piacmd.h \
+ $(INC)dlftypes.h \
+ $(INC)pdlmgr.h \
+ $(INC)nobjmgr.h \
+ $(INC)anydataobj.h \
+ $(INC)ppersist.h \
+ $(INC)pexceptions.h \
+ $(INC)gnumd5.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)mutyv.h \
+ $(INC)pistdimgapp.h \
+ $(INC)pisysdep.h \
+ $(INC)piapplx.h \
+ $(INC)piapplgen.h \
+ $(INC)pimsghandler.h \
+ $(INC)picontainerx.h \
+ $(INC)picontainergen.h \
+ $(INC)piwdgx.h \
+ $(INC)piwdggen.h \
+ $(INC)picolist.h \
+ $(INC)pimenubarx.h \
+ $(INC)pimenubargen.h \
+ $(INC)pimenux.h \
+ $(INC)pimenugen.h \
+ $(INC)picons.h \
+ $(INC)pistdwdgx.h \
+ $(INC)pistdwdggen.h \
+ $(INC)pibwdgx.h \
+ $(INC)pibwdggen.h \
+ $(INC)picmap.h \
+ $(INC)picmapx.h \
+ $(INC)picmapgen.h \
+ $(INC)pigraphx.h \
+ $(INC)pigraphgen.h \
+ $(INC)pifontx.h \
+ $(INC)pifontgen.h \
+ $(INC)pigraphuc.h \
+ $(INC)pievthandler.h \
+ $(INC)psfile.h \
+ $(INC)pigraphps.h \
+ $(INC)piwindowx.h \
+ $(INC)piwindowgen.h \
+ $(INC)pioptmenux.h \
+ $(INC)pioptmenugen.h \
+ $(INC)pifilechox.h \
+ $(INC)pifilechogen.h \
+ $(INC)piimage.h \
+ $(INC)parradapter.h \
+ $(INC)lut.h \
+ $(INC)pidrawer.h \
+ $(INC)pipixmapx.h \
+ $(INC)pipixmapgen.h \
+ $(INC)picmapview.h \
+ $(INC)pi3ddrw.h \
+ $(INC)pigraph3d.h \
+ $(INC)pisiadw.h \
+ $(INC)pilistx.h \
+ $(INC)pilistgen.h \
+ $(INC)pistzwin.h \
+ $(INC)piperiodx.h \
+ $(INC)periodic.h \
+ $(INC)servnobjm.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h \
+ $(INC)pitvmaad.h \
+ $(INC)fftpserver.h \
+ $(INC)fftservintf.h \
+ $(INC)bruit.h \
+ $(INC)piscdrawwdg.h \
+ $(INC)ctimer.h
Index: trunk/SophyaProg/PMixer/Makefile
===================================================================
--- trunk/SophyaProg/PMixer/Makefile	(revision 1373)
+++ trunk/SophyaProg/PMixer/Makefile	(revision 1374)
@@ -92,4 +92,5 @@
  $(INC)unitvector.h \
  $(INC)spherehealpix.h \
+ $(INC)HEALPixUtils.h \
  $(INC)fitsspherehealpix.h \
  $(INC)fitsfile.h \
@@ -168,4 +169,5 @@
  $(INC)unitvector.h \
  $(INC)spherehealpix.h \
+ $(INC)HEALPixUtils.h \
  $(INC)fitsspherehealpix.h \
  $(INC)fitsfile.h \
@@ -221,4 +223,5 @@
  $(INC)unitvector.h \
  $(INC)spherehealpix.h \
+ $(INC)HEALPixUtils.h \
  $(INC)fitsspherehealpix.h \
  $(INC)fitsfile.h \
@@ -273,4 +276,5 @@
  $(INC)unitvector.h \
  $(INC)spherehealpix.h \
+ $(INC)HEALPixUtils.h \
  $(INC)fitsspherehealpix.h \
  $(INC)fitsfile.h \
@@ -325,19 +329,20 @@
  $(INC)unitvector.h \
  $(INC)spherehealpix.h \
- $(INC)fitsspherehealpix.h \
- $(INC)fitsfile.h \
- $(INC)fitstarray.h \
- $(INC)cimage.h \
- $(INC)radspecvector.h \
- $(INC)radspec.h \
- $(INC)specresp.h \
- $(INC)blackbody.h \
- $(INC)convtools.h \
- $(INC)derivblackbody.h \
- $(INC)nupower.h \
- $(INC)squarefilt.h \
- $(INC)trianglefilt.h \
- $(INC)specrespvector.h \
- $(INC)gaussfilt.h \
- $(INC)bruit.h \
- $(INC)mapoperation.h
+ $(INC)HEALPixUtils.h \
+ $(INC)fitsspherehealpix.h \
+ $(INC)fitsfile.h \
+ $(INC)fitstarray.h \
+ $(INC)cimage.h \
+ $(INC)radspecvector.h \
+ $(INC)radspec.h \
+ $(INC)specresp.h \
+ $(INC)blackbody.h \
+ $(INC)convtools.h \
+ $(INC)derivblackbody.h \
+ $(INC)nupower.h \
+ $(INC)squarefilt.h \
+ $(INC)trianglefilt.h \
+ $(INC)specrespvector.h \
+ $(INC)gaussfilt.h \
+ $(INC)bruit.h \
+ $(INC)mapoperation.h