Index: trunk/SophyaExt/FitsIOServer/fitsfile.cc
===================================================================
--- trunk/SophyaExt/FitsIOServer/fitsfile.cc	(revision 1371)
+++ trunk/SophyaExt/FitsIOServer/fitsfile.cc	(revision 1379)
@@ -574,5 +574,5 @@
     else
       {
-	cout << " hdutype= " << hdutype_ << endl;
+	cout << " hdutype= " << (int) hdutype_ << endl;
 	throw PException("FitsFile::NbColsFromFits, HDU  not supported");
       }
@@ -592,5 +592,5 @@
       else
 	{
-	  cout << "hdutype= " << hdutype_ << endl;
+	  cout << "hdutype= " << (int) hdutype_ << endl;
 	  throw PException("FitsFile::NentriesFromFits, this HDU is not supported");
 	}
@@ -781,5 +781,5 @@
 \param <nentries>  number of data to be read
 */
-void FitsInFile::GetBinTabFCol(double* valeurs,int nentries, int NoCol) const
+void FitsInFile::GetBinTabFCol(r_8* valeurs,int nentries, int NoCol) const
     {
       int status= 0;
@@ -818,5 +818,5 @@
  same as previous method with float data 
 */
-void FitsInFile::GetBinTabFCol(float* valeurs,int nentries, int NoCol) const
+void FitsInFile::GetBinTabFCol(r_4* valeurs,int nentries, int NoCol) const
     {
       int status= 0;
@@ -855,5 +855,5 @@
 */
 
-void FitsInFile::GetBinTabFCol(int* valeurs,int nentries, int NoCol) const
+void FitsInFile::GetBinTabFCol(int_4* valeurs,int nentries, int NoCol) const
     {
       int status= 0;
@@ -922,5 +922,5 @@
 \param <nentries>  number of data to be read
 */
-void FitsInFile::GetSingleColumn(double* map, int nentries) const
+void FitsInFile::GetSingleColumn(r_8* map, int nentries) const
 { 
   int status = 0;
@@ -949,5 +949,5 @@
     else
       {
-      cout << " hdutype= " << hdutype_ << endl;
+      cout << " hdutype= " << (int) hdutype_ << endl;
       throw IOExc("FitsFile::GetSingleColumn, this HDU is unknown");
       }
@@ -957,5 +957,5 @@
 same as above with float data 
 */
-void FitsInFile::GetSingleColumn(float* map, int nentries) const
+void FitsInFile::GetSingleColumn(r_4* map, int nentries) const
 {
   int status = 0;
@@ -982,5 +982,5 @@
     else
       {
-      cout << " hdutype= " << hdutype_ << endl;
+      cout << " hdutype= " << (int) hdutype_ << endl;
       throw IOExc("FitsFile::GetSingleColumn this HDU is unknown");
       }
@@ -990,5 +990,5 @@
  same as above with int data 
 */
-void FitsInFile::GetSingleColumn( int* map, int nentries) const
+void FitsInFile::GetSingleColumn( int_4* map, int nentries) const
 {
   int status = 0;
@@ -1015,5 +1015,5 @@
     else
       {
-      cout << " hdutype= " << hdutype_ << endl;
+      cout << " hdutype= " << (int) hdutype_ << endl;
       throw IOExc("FitsFile::GetSingleColumn this HDU is unknown");
       }
@@ -1401,5 +1401,5 @@
 \param <nbData>  number of data to be written
 */
-void FitsOutFile::PutImageToFits(int nbData, double* map) const
+void FitsOutFile::PutImageToFits(int nbData, r_8* map) const
 {
   int status = 0;
@@ -1413,5 +1413,5 @@
 same as previous method with float data 
 */
-void FitsOutFile::PutImageToFits(int nbData, float* map) const
+void FitsOutFile::PutImageToFits(int nbData, r_4* map) const
 {
   int status = 0;
@@ -1425,5 +1425,5 @@
 
  same as previous method with int data */
-void FitsOutFile::PutImageToFits( int nbData, int* map) const
+void FitsOutFile::PutImageToFits( int nbData, int_4* map) const
 {
   int status = 0;
@@ -1563,5 +1563,5 @@
 */
 
-void FitsOutFile::PutColToFits(int nocol, int nentries, double* donnees) const
+void FitsOutFile::PutColToFits(int nocol, int nentries, r_8* donnees) const
 {
   int status = 0;
@@ -1592,5 +1592,5 @@
 same as previous method with float data 
 */
-void FitsOutFile::PutColToFits(int nocol, int nentries, float* donnees) const
+void FitsOutFile::PutColToFits(int nocol, int nentries, r_4* donnees) const
 {
   int status = 0;
@@ -1624,5 +1624,5 @@
 same as previous method with int data 
 */
-void FitsOutFile::PutColToFits(int nocol, int nentries, int* donnees) const
+void FitsOutFile::PutColToFits(int nocol, int nentries, int_4* donnees) const
 {
   int status = 0;